package email

import (
	"gopkg.in/gomail.v2"
	"mylomen_server/common/logs"
)

func sendNoticeEmail(subject, content string, address ...string) error {
	gm := gomail.NewMessage()
	gm.SetHeader("From", "<support@notice.mylomen.com>")
	if len(address) == 1 {
		gm.SetHeader("To", address[0])
	} else {
		gm.SetHeader("To", address...)
	}

	gm.SetHeader("Subject", subject)
	gm.SetBody("text/html", content)
	d := gomail.NewDialer(
		"email-smtp.us-east-2.amazonaws.com",
		465,
		"AKIA6ILZQBMNF4T7HLJV",
		"BH5TmE3FdgYs8tepWQZW5LLvbryQ+sWJde7+sAm++0/E",
	)

	err := d.DialAndSend(gm)
	if err != nil {
		logs.NewLog("").Errorf("html邮件 发送异常 subject: %s address: %s err: %+v", subject, address[0], err)
		return err
	}

	logs.NewLog("").Infof("html邮件 发送成功 subject: %s address: %s", subject, address[0])
	return nil
}
